#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=LBMonitor.ico
#AutoIt3Wrapper_UseUpx=y
#AutoIt3Wrapper_Res_Fileversion=2.4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include<File.au3>

#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("LBMonitor V2.4", 268, 129, 316, 176)
$Combo1 = GUICtrlCreateCombo("", 16, 88, 145, 25)
GUICtrlSetData(-1, "ErroredSecs|SeverelyErroredSecs|FECErrors|ATUCFECErrors|HECErrors|ATUCHECErrors|CRCErrors|ATUCCRCErrors|UpstreamNoiseMargin|DownstreamNoiseMargin|UpstreamAttenuation|DownstreamAttenuation","ErroredSecs")
$Button1 = GUICtrlCreateButton("Graph", 176, 88, 67, 22)
$Input1 = GUICtrlCreateInput("1", 16, 24, 65, 21, $ES_NUMBER) ; on autorise que les chiffres
$Label1 = GUICtrlCreateLabel("Cycle de lecture des données en Minutes:", 16, 8, 202, 16)
$Button2 = GUICtrlCreateButton("Lancer", 96, 24, 67, 22)
$Button3 = GUICtrlCreateButton("Arrêter", 176, 24, 67, 22)
	GUICtrlSetState($Button3,$GUI_DISABLE)
$Input2 = GUICtrlCreateInput("", 16, 56, 145, 21)
	GUICtrlSetState($Input2,$GUI_DISABLE)
$Button4 = GUICtrlCreateButton("Fichier", 176, 56, 67, 25)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###



Opt("TrayIconHide", 1) ;0=show, 1=hide tray icon

Global $USER = "admin"
Global $LIVEBOX = "livebox"
Global $sContextID = ""
Global $PASSWORD = ""



; On vérifie que le fichier INI est bien présent
$sFilePath = @scriptDir & "\config.ini"
$iFileExists = FileExists($sFilePath)
if $iFileExists Then
	Global $LIVEBOX = IniRead (@scriptDir & "\config.ini","setting","LiveboxIP","192.168.1.1")
	Global $PASSWORD = IniRead (@scriptDir & "\config.ini","setting","password","")
Else
	$Filepath = @ScriptDir & "\config.ini"
	FileOpen($Filepath, 1)
	FileWriteLine($Filepath,"[setting]")
	FileWriteLine($Filepath,"LiveboxIP=192.168.1.1")
	FileWriteLine($Filepath,"password=XXXXXXXX")
	msgbox(48,"ERREUR","Veuillez indiquer votre mot de passe Livebox dans le fichier CONFIG.INI")
	Exit
EndIf

; On vérifie que les étourdis ont bien mis leur mot de passe
if ($PASSWORD ="" or $PASSWORD="XXXXXXXX") Then
	msgbox(48,"ERREUR","Veuillez indiquer votre mot de passe Livebox dans le fichier CONFIG.INI")
	Exit
EndIf

$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE ; Fermeture application
			_Logout()
			Exit

		Case $Button1 ; Affichage du Graph
			_GetChart()

		Case $Button2 ; Execution du cycle de lecture des données

			GUICtrlSetState($Button3,$GUI_ENABLE)  ; on active le bouton ARRETER
			GUICtrlSetState($Button2,$GUI_DISABLE) ; on désactive le bouton LANCER

			_GetData() ; On récupère les données

			$cycle = GUICtrlRead($Input1)
			$cycle = $cycle * 60000 ; conversion en minutes
			AdlibRegister("_GetData",$cycle) ; execute la fonction _GetData toutes les x minutes

		Case $Button3 ; ARRET de l'execution du cycle de lecture des données

			GUICtrlSetState($Button2,$GUI_ENABLE)  ; on active le bouton LANCER
			GUICtrlSetState($Button3,$GUI_DISABLE) ; on désactive le bouton ARRETER
			AdlibUnRegister("_GetData") ; on arrete le cycle de lecture

		Case $Button4
			Local $sFileOpenDialog = FileOpenDialog("Choisir un fichier de données", @ScriptDir & "\data", "TXT (*.txt)", $FD_FILEMUSTEXIST)
			if $sFileOpenDialog <>"" then
				guictrlsetdata($input2,$sFileOpenDialog)
			EndIf

	EndSwitch
WEnd


Func _GetData()

auth_livebox() ; connexion à la LiveBox

; Recuperation des donnees DSLStats
$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NeMo/Intf/dsl0:getDSLStats", False)
$oHTTP.SetRequestHeader("X-Context", $sContextID)
$oHTTP.Send('{"parameters":{}}')
$getDSLStats = $oHTTP.ResponseText

; Recuperation des donnees MIBs
$oHTTP.Open("POST", "http://" & $LIVEBOX & "/sysbus/NeMo/Intf/data:getMIBs", False)
$oHTTP.SetRequestHeader("X-Context", $sContextID)
$oHTTP.Send('{"parameters":{"mibs":"dsl","flag":"","traverse":"down"}}')
$getMIBs = $oHTTP.ResponseText

$ErroredSecs = StringRegExp($getDSLStats, '(?U)ErroredSecs":(.*),', 3)
$SeverelyErroredSecs = StringRegExp($getDSLStats, '(?U)SeverelyErroredSecs":(.*),', 3)
$FECErrors = StringRegExp($getDSLStats, '(?U)FECErrors":(.*),', 3)
$ATUCFECErrors = StringRegExp($getDSLStats, '(?U)ATUCFECErrors":(.*),', 3)
$HECErrors = StringRegExp($getDSLStats, '(?U)HECErrors":(.*),', 3)
$ATUCHECErrors = StringRegExp($getDSLStats, '(?U)ATUCHECErrors":(.*),', 3)
$CRCErrors = StringRegExp($getDSLStats, '(?U)CRCErrors":(.*),', 3)
$ATUCCRCErrors = StringRegExp($getDSLStats, '(?U)ATUCCRCErrors":(.*)}', 3)

$UpstreamNoiseMargin = StringRegExp($getMIBs, '(?U)UpstreamNoiseMargin":(.*),', 3)
$DownstreamNoiseMargin = StringRegExp($getMIBs, '(?U)DownstreamNoiseMargin":(.*),', 3)
$UpstreamAttenuation = StringRegExp($getMIBs, '(?U)UpstreamAttenuation":(.*),', 3)
$DownstreamAttenuation = StringRegExp($getMIBs, '(?U)DownstreamAttenuation":(.*),', 3)

; format date = 2015-08-22T18:29:44
$data = @YEAR & "-" & @MON & "-" & @MDAY & "T" & @HOUR & ":" & @MIN & ":" & @SEC & "," & _
$ErroredSecs[0] & "," & _
$SeverelyErroredSecs[0] & "," & _
$FECErrors[0] & "," & _
$ATUCFECErrors[0] & "," & _
$HECErrors[0] & "," & _
$ATUCHECErrors[0] & "," & _
$CRCErrors[0] & "," & _
$ATUCCRCErrors[0] & "," & _
$UpstreamNoiseMargin[0] & "," & _
$DownstreamNoiseMargin[0] & "," & _
$UpstreamAttenuation[0] & "," & _
$DownstreamAttenuation[0]

$date = @YEAR & @MON & @MDAY
$filename = $date & ".txt"
$Filepath = fileopen(@SCRIPTDIR & "\data\" & $filename,9)

FileWriteLine($Filepath,$data)
Fileclose($Filepath)

guictrlsetdata($input2, @ScriptDir & "\data\" & $filename)

Endfunc ;==>_GetData

Func _GetChart()
	$fichierdata = GUICtrlRead($input2)
	$choix = GUICtrlRead($Combo1)
	select
		Case $choix = "ErroredSecs"
			Local $c=2, $ytitle="&ytitle=Erreurs"
		Case $choix = "SeverelyErroredSecs"
			Local $c=3, $ytitle="&ytitle=Erreurs"
		Case $choix = "FECErrors"
			Local $c=4, $ytitle="&ytitle=Erreurs"
		Case $choix = "ATUCFECErrors"
			Local $c=5, $ytitle="&ytitle=Erreurs"
		Case $choix = "HECErrors"
			Local $c=6, $ytitle="&ytitle=Erreurs"
		Case $choix = "ATUCHECErrors"
			Local $c=7, $ytitle="&ytitle=Erreurs"
		Case $choix = "CRCErrors"
			Local $c=8, $ytitle="&ytitle=Erreurs"
		Case $choix = "ATUCCRCErrors"
			Local $c=9, $ytitle="&ytitle=Erreurs"
		Case $choix = "UpstreamNoiseMargin"
			Local $c=10, $ytitle="&ytitle=dB"
		Case $choix = "DownstreamNoiseMargin"
			Local $c=11, $ytitle="&ytitle=dB"
		Case $choix = "UpstreamAttenuation"
			Local $c=12, $ytitle="&ytitle=dB"
		Case $choix = "DownstreamAttenuation"
			Local $c=13, $ytitle="&ytitle=dB"
	EndSelect

	if $fichierdata = "" Then
		$filename = @SCRIPTDIR & "\data\" & @YEAR & @MON & @MDAY & ".txt"
	else
		$filename = $fichierdata
	EndIf

	$lines = _FileCountLines($filename)
	$Filepath = fileopen($filename,0)

	Local $x="", $y = ""

	For $i = 1 to $lines
		$line = FileReadLine($Filepath)
		$data = StringSplit($line,",")

		if $c>9 Then ; on affiche les dB correctement
			$data[$c] = $data[$c] / 10
		EndIf

		if $i = $lines Then ; on ne met pas de "," après la dernière valeur
			$x = $x & '{"date":"' & $data[1] & '","visits":' & $data[$c] & '}'
		Else
			$x = $x & '{"date":"' & $data[1] & '","visits":' & $data[$c] & '},'
		Endif

	Next
	Fileclose($Filepath)

	;récupération de la date du fichier...Bonjour l'usine a gaz !
	$g = StringSplit($filename,"\")
	$h = ubound($g) - 1
	$i = StringSplit($g[$h],".")
	$year = StringLeft($i[1],4) ; l'année c'est les 4 caractères de gauche du fichier txt
	$day = stringright($i[1],2) ; le jour: les 2 de droite
	$mon = StringMid($i[1],5,2) ; et le mois: les 2 caractères à partir du 5eme de la gauche...


	$template = fileopen(@SCRIPTDIR & "\" & "template.html",0)
	$html = fileread($template)
	$html = stringreplace($html,"XXXXXXXX",$x)
	$html = stringreplace($html,"TITRE",$choix & " - " & $day & "-" & $mon & "-" & $year)

	$graph = fileopen(@SCRIPTDIR & "\graph\" & $choix & ".html",10)
	FileWrite($graph, $html)

	fileclose($graph)
	fileclose($template)

	shellexecute(@ScriptDir & "\graph\" & $choix & ".html")

EndFunc   ;==>_GetChart


Func _Logout()
	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/logout", False)
	$oHTTP.Send()
	$oHTTP = 0
EndFunc   ;==>_Logout


Func auth_livebox()
	$str = "/authenticate?username=" & $USER & "&password=" & $PASSWORD
	$oHTTP.Open("POST", "http://" & $LIVEBOX & $str, False)
	$oHTTP.SetRequestHeader("Content-Type", "application/json")
	$oHTTP.Send()
	$oReceived = $oHTTP.ResponseText
	$sContextID = StringRegExp($oReceived, 'contextID":"([^"]+)"|()$', 1)[0]
	If $sContextID = "" Then
		MsgBox(48, "ERREUR", " Mot de passe incorrect : ")
		Return "NOLOGIN"
	EndIf
EndFunc   ;==>auth_livebox